unit CopySetting;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls;

type
  TSettingForm = class(TForm)
    Button1: TButton;
    Button2: TButton;
    CopyParam: TGroupBox;
    UpDown1: TUpDown;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Button3: TButton;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    Edit1: TEdit;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    FExtentedSetting : Boolean;
    procedure SetExtentedSetting(Extented : Boolean);
    property ExtentedSetting : Boolean read FExtentedSetting write SetExtentedSetting;
  public
    { Public declarations }
  end;

const
  stFromTopAddr = $FFFFFFFF;
  stFromSelectAddr = $FFFFFFFE;

var
  CopyLineCount : Integer = 30;
  CopyLineMode : DWORD = stFromTopAddr;
  SettingToAll : Boolean;

implementation

{$R *.dfm}

var
  SettingForm: TSettingForm;
  ExtentedSet : Boolean = false;

procedure TSettingForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TSettingForm.SetExtentedSetting(Extented : Boolean);
begin
  FExtentedSetting := Extented;
  if Extented then
  begin
    Width := 350;
    Button3.Caption := '<<';
  end
  else
  begin
    Width := 200;
    Button3.Caption := '>>';
  end;
end;

procedure TSettingForm.FormCreate(Sender: TObject);
begin
  SettingForm := Self;
  Edit1.Text := IntToStr(CopyLineCount);
  case CopyLineMode of
    stFromTopAddr : RadioButton1.Checked := True;
    stFromSelectAddr : RadioButton2.Checked := True;
  end;
  ExtentedSetting := ExtentedSet;
  CheckBox1.Checked := SettingToAll;
end;

procedure TSettingForm.Button3Click(Sender: TObject);
begin
  ExtentedSet := not ExtentedSetting;
  ExtentedSetting := ExtentedSet;
end;

procedure TSettingForm.Button1Click(Sender: TObject);
begin
  CopyLineCount := StrToIntDef(Edit1.Text, 0);
  if RadioButton1.Checked then
    CopyLineMode := stFromTopAddr
  else
    CopyLineMode := stFromSelectAddr;
  SettingToAll := CheckBox1.Checked;
end;

end.
