unit HelperTools;
{$WARNINGS OFF}

interface
uses
  Windows, SysUtils, Controls, Classes;

type
  TWindowObject = class
    WinHandle    : HWnd;    {Window Handle}
    WinCaption   : String;  {Window Caption Text (If any)}
    WinClassName : String;
    IsVisible    : Boolean; {Is the window visible?}
    IsEnabled    : Boolean; {Is the window enabled for mouse/keyboard input?}
    IsIconic     : Boolean; {Is the window minimized?}
    WindowRect   : TRect;   {Window Dimensions}
  end;

//תڵַ󷽷
function InitObjMethod(SelfObj, CallAddr:Pointer) : TMethod;

//Hwndȡ(Libary, .exe, ʹFindControl())
function ObjectFromHWnd(Handle: HWnd): TWinControl;

{//ֻDelphi 7ʹãҲڸ߰汾Delphi
procedure InitThreadEnvironment_D7(Handle: HWnd);
function ObjectFromHWnd_D7(Handle: HWnd): TWinControl;
}

//HwndȡϢ
function GetWndObj(Handle : HWnd) : TWindowObject;

//ȡб
function EnumWndList(Parent : HWnd): TObject;

//ͨȡHwnd
function HwndByClassName(ClassName : String; PID : Integer = 0) : HWND;

//һͨEnumWndList()õĴбвҴ
function FindHwndFromList(aWndList : TObject; ClassName : String; Caption : String = '') : HWND;

implementation


function InitObjMethod(SelfObj, CallAddr:Pointer) : TMethod;
begin
  Result.Code := CallAddr;
  Result.Data := SelfObj;
end;

var  //define in Controls.pas
  RM_GetObjectInstance : DWORD;
  ControlAtomString : String;

procedure InitThreadEnvironment(Handle: HWnd);
var
  ProcessID, ThreadID : DWORD;
  HInst : DWORD;
begin
  HInst := GetWindowLong(Handle, GWL_HINSTANCE);
  ThreadID := GetWindowThreadProcessID(Handle, @ProcessID);
  ControlAtomString := Format('ControlOfs%.8X%.8X', [HInst, ThreadID]);
end;

function ObjectFromHWnd(Handle: HWnd): TWinControl;
var
  OwningProcess: DWORD;
begin
  //next line by Aimingoo
  InitThreadEnvironment(Handle);
  if (GetWindowThreadProcessID(Handle, @OwningProcess) <> 0) and
     (OwningProcess = GetCurrentProcessID) then
    Result := Pointer(GetProp(Handle, MakeIntAtom(ControlAtomString)))
  else
    Result := nil;
end;

procedure InitThreadEnvironment_D7(Handle: HWnd);
begin
  InitThreadEnvironment(Handle);
  RM_GetObjectInstance := RegisterWindowMessage(PChar(ControlAtomString));
end;

//in Delphi7, FindControl() will Send Message RM_GetObjectInstance
function ObjectFromHWnd_D7(Handle: HWnd): TWinControl;
var
  OwningProcess: DWORD;
begin
  //next line by Aimingoo
  InitThreadEnvironment_D7(Handle);
  if (GetWindowThreadProcessID(Handle, @OwningProcess) <> 0) and
     (OwningProcess = GetCurrentProcessID) then
    Result := Pointer(SendMessage(Handle, RM_GetObjectInstance, 0, 0))
  else
    Result := nil;
end;

function GetWndObj(Handle : HWnd) : TWindowObject;
begin
  Result := TWindowObject.Create;
  with Result do
  begin
    SetLength(WinCaption, 255);
    SetLength(WinClassName, 255);
    WindowRect := Rect(0, 0, 0, 0);
    WinHandle := Handle;
    SetLength(WinCaption, GetWindowText(Handle, @WinCaption[1], 255));
    SetLength(WinClassName, GetClassName(Handle, @WinClassName[1], 255));
    IsVisible := IsWindowVisible(Handle);
    IsEnabled := IsWindowEnabled(Handle);
    IsIconic := Windows.IsIconic(Handle);
    GetWindowRect(Handle, WindowRect);
  end;
end;

function EnumWndList(Parent : HWnd): TObject;
var
  Handle : Hwnd;
begin
  Handle := FindWindowEx(Parent, 0, nil, nil);
  if Handle = 0 then
    Result := GetWndObj(Parent)
  else
  begin
    Result := TList.Create;
    TList(Result).Add(GetWndObj(Parent));
    repeat
      TList(Result).Add(EnumWndList(Handle));
      Handle := FindWindowEx(Parent, Handle, nil, nil);
    until Handle = 0;
  end;
end;

function EnumFunc(Handle : HWnd; var PI64 : Int64Rec): Bool; stdcall;
var
  _ClassName : array [0..255] of Char;
  PID  : Cardinal;
begin
  Result := True;
  PID := 0;
  GetWindowThreadProcessId(Handle, @PID);
  if PID = PI64.Lo then
  begin
    GetClassName(Handle, @_ClassName[0], 255);
    if StrComp(_ClassName, pChar(PI64.Hi)) = 0 then
    begin
      PI64.Hi := Handle;
      Result := False;
    end;
  end;
end;

function HwndByClassName(ClassName : String; PID : Integer = 0) : HWND;
var
  PI64 : Int64Rec;
begin
  if PID=0 then
    PI64.Lo := GetCurrentProcessID
  else
    PI64.Lo := PID;

  PI64.Hi := Integer(pChar(ClassName));
  EnumWindows(@EnumFunc, Integer(@PI64));
  if PI64.Hi = Cardinal(pChar(ClassName)) then
    Result := 0
  else
    Result := PI64.Hi;
end;

function FindHwndFromList(aWndList : TObject; ClassName : String; Caption : String = '') : HWND;
var
  i : Integer;
  WNDs : TList;
  aObj : TWindowObject;
begin
  Result := 0;
  if aWndList is TWindowObject then
  begin
    aObj := TWindowObject(aWndList);
    if (aObj.WinClassName = ClassName) and
       ((Caption = '') or (Caption = aObj.WinCaption)) then
      Result  := aObj.WinHandle;
  end
  else
  begin
    WNDs := aWndList as TList;
    for i := 0 to WNDs.Count - 1 do
    begin
      Result := FindHwndFromList(WNDs[i], ClassName, Caption);
      if Result <> 0 then
        Break;
    end;
  end;
end;


end.
